/**
 * GetMessage.java
 * Created on 2004/02/23
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package lapis.logic;

import javax.servlet.http.HttpServletRequest;

import net.prixdami.alexis.dataaccess.DataAccessManager;
import net.prixdami.alexis.logic.Message;
import net.prixdami.alexis.view.Decorator;

import org.apache.velocity.VelocityContext;

/**
 * @author es
 */
public class GetMessage extends Decorator {

    private DataAccessManager dam;
    public static final String TARGET = "reply";

    /* ( Javadoc)
     * @see net.prixdami.alexis.view.Decorator#init()
     */
    public void init() {
		dam = DataAccessManager.getInstace();
    }

    /* ( Javadoc)
     * @see net.prixdami.alexis.view.Decorator#decorate(org.apache.velocity.VelocityContext, javax.servlet.http.HttpServletRequest)
     */
    public VelocityContext decorate(VelocityContext context, HttpServletRequest request) throws Exception {
		VelocityContext c = new VelocityContext(context);
        Message[] m = dam.acquire(TARGET, 0, 999);
        c.put("messageArray", m);
        return c;
    }

}
