/**
 * GenericResult.java
 * Created on 2003/06/09
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package net.prixdami.alexis.model;

/**
 * ėpResultModel
 * RXgN^ŃXe[^XR[hƎsʂ^Ďg
 * @author es
 * @version 
 */
public class GenericResult implements ResultModel {

    private Object resultValue;
    private int resultCode;

    private GenericResult() {
    }

    /**
     * Constructor for GenericResult.
     */
    public GenericResult(Object resultValue, int resultCode) {
        this.resultValue = resultValue;
        this.resultCode = resultCode;
    }

    /**
     * getResultCode
     * @return int 
     * @see net.prixdami.alexis.model.ResultModel#getResultCode()
     */
    public int getResultCode() {
        return resultCode;
    }

    /**
     * getResult
     * @return Object
     * @see net.prixdami.alexis.model.ResultModel#getResult()
     */
    public Object getResult() {
        return resultValue;
    }

    /**
     * Sets the resultCode.
     * @param resultCode The resultCode to set
     */
    public void setResultCode(int resultCode) {
        this.resultCode = resultCode;
    }

    /**
     * Sets the resultValue.
     * @param resultValue The resultValue to set
     */
    public void setResult(Object resultValue) {
        this.resultValue = resultValue;
    }

    public String toString() {
        return resultCode + resultValue.toString();
    }

}
